<template>
  <v-container fluid fill-height>
    <v-layout align-center justify-center>
      <v-flex xs12 sm8 md4>
        <v-card class="elevation-12">
          <v-toolbar dark color="primary">
            <v-toolbar-title>Login SAC-24</v-toolbar-title>
          </v-toolbar>
          <v-card-text>
            <v-form>
              <v-text-field
                  :disabled="statusProgress"
                  prepend-icon="person"
                  v-model="username"
                  :error-messages="error_payload.username"
                  label="Login"
                  type="text"
                  autofocus
                  @blur="setResetError"
                  @input="setResetError"
              ></v-text-field>
              <v-text-field
                  :disabled="statusProgress"
                  id="password"
                  prepend-icon="lock"
                  v-model="password"
                  :error-messages="error_payload.password"
                  label="Password"
                  type="password"
                  @blur="setResetError"
                  @input="setResetError"
              ></v-text-field>
              <v-text-field
                  label="version"
                  prepend-icon="info"
                  :value="version"
                  readonly
              />
            </v-form>
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="primary" @click="doLogin" :disabled="statusProgress">Login</v-btn>
          </v-card-actions>
        </v-card>
      </v-flex>
    </v-layout>
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";
import {checkError400} from "../utils/util";

export default {
  name: "Login",
  components: {
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      username: null,
      password: null,
      version: process.env.VUE_APP_VERSION,
      statusProgress: false,
      error_payload: {
        username: [],
        password: []
      }
    }
  },
  methods: {
    async doLogin() {
      let username = this.username
      let password = this.password
      this.statusProgress = true
      await this.$store.dispatch('doChoiceOtp', {username, password})
          .then(async resp => {
            let res = resp.data
            if (res.status === 'FAILED') {
              this.$refs.dlgMsg.doOpenMsg(res.message)
              return false
            }
            if (this.$store.getters.isValidTmp) {
              await this.$router.push('/choice/otp')
            }
          }).catch(err => {
            checkError400(err, this.$refs.dlgMsg, this.error_payload)
          })
      this.statusProgress = false
    },
    setResetError() {
      this.error_payload.username = [];
      this.error_payload.password = [];
    }
  },
  async created() {
    this.statusProgress = true
    if (this.$store.getters.isLoggedIn) {
      await window._VMA.$emit('DASHBORAD')
    }
    this.statusProgress = false
  }
}
</script>

<style scoped>

</style>